## highs 1.11.0+ds

=== app/CMakeLists.txt ===
if(FAST_BUILD)
  if (BUILD_CXX_EXE)
    # Configure the config windows version file
    if(MSVC)
      string(REPLACE "." ","  PROJECT_RC_VERSION "${PROJECT_VERSION}")
      configure_file(${PROJECT_SOURCE_DIR}/version.rc.in
        "${HIGHS_BINARY_DIR}/version.rc" @ONLY)
      set(win_version_file ${HIGHS_BINARY_DIR}/version.rc)
    else()
      set(win_version_file)
    endif()

    add_executable(highs-bin)
    target_sources(highs-bin PRIVATE RunHighs.cpp HighsRuntimeOptions.h ${win_version_file})

    target_include_directories(highs-bin PRIVATE
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/app>
    )

    set_target_properties(highs-bin PROPERTIES POSITION_INDEPENDENT_CODE ON)

    if(UNIX)
      target_compile_options(highs-bin PUBLIC "-Wno-unused-variable")
      target_compile_options(highs-bin PUBLIC "-Wno-unused-const-variable")
    endif()

    set_target_properties(highs-bin PROPERTIES OUTPUT_NAME highs)

    target_compile_features(highs-bin PRIVATE cxx_std_11)
    target_link_libraries(highs-bin PRIVATE ${PROJECT_NAMESPACE}::highs)

    include(GNUInstallDirs)

    if(APPLE)
        set_target_properties(highs-bin PROPERTIES INSTALL_RPATH 
        "@loader_path/../${CMAKE_INSTALL_LIBDIR};@loader_path")
    elseif (UNIX)
        set_target_properties(highs-bin PROPERTIES INSTALL_RPATH 
        "$ORIGIN:$ORIGIN/../${CMAKE_INSTALL_LIBDIR}")
      
      # cmake_path is 3.20, leave for later.
      # cmake_path(RELATIVE_PATH CMAKE_INSTALL_FULL_LIBDIR
      #        BASE_DIRECTORY ${CMAKE_INSTALL_FULL_BINDIR}
      #        OUTPUT_VARIABLE libdir_relative_path)
      # set_target_properties(highs-bin PROPERTIES INSTALL_RPATH
      #   "$ORIGIN/${libdir_relative_path}")
    endif()

    # install the binary
    install(TARGETS highs-bin 
      EXPORT highs-targets
      RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

    if(BUILD_TESTING)
      if (APPLE)
        set(CMAKE_INSTALL_RPATH
                "@loader_path/../${CMAKE_INSTALL_LIBDIR};@loader_path")
      elseif (UNIX)
        set(CMAKE_INSTALL_RPATH "$ORIGIN/../${CMAKE_INSTALL_LIBDIR}:$ORIGIN:$ORIGIN/../lib:$ORIGIN")
      endif ()
    endif()

  endif()
else()
  # create highs binary using library without pic
  add_executable(highs)

  target_sources(highs PRIVATE RunHighs.cpp)

  if(UNIX)
    target_compile_options(highs PUBLIC "-Wno-unused-variable")
    target_compile_options(highs PUBLIC "-Wno-unused-const-variable")
  endif()

  target_link_libraries(highs libhighs)

  target_include_directories(highs PRIVATE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/app>
  )

  # install the binary
  install(TARGETS highs EXPORT highs-targets
    RUNTIME)
endif()

# Add demo to FAST_BUILD as well.
if(EMSCRIPTEN AND EMSCRIPTEN_HTML)
  set(CMAKE_EXECUTABLE_SUFFIX ".html")
  set_target_properties(highs PROPERTIES LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/highs_webdemo_shell.html)
endif()

=== check/CMakeLists.txt ===
include(CTest)

if (FORTRAN AND NOT BUILD_EXTRA_UNIT_ONLY)
    set(CMAKE_Fortran_MODULE_DIRECTORY ${HIGHS_BINARY_DIR}/modules)
    add_executable(fortrantest TestFortranAPI.f90)
    if (NOT FAST_BUILD)
        target_link_libraries(fortrantest libhighs FortranHighs)
    else()
        target_link_libraries(fortrantest highs FortranHighs)
    endif()
    target_include_directories(fortrantest PUBLIC 
        ${PROJECT_SOURCE_DIR}/highs/interfaces
        ${PROJECT_SOURCE_DIR}/check)
endif()


if ((NOT FAST_BUILD OR ALL_TESTS) AND NOT (BUILD_EXTRA_UNIT_ONLY))
  # prepare Catch library
  set(CATCH_INCLUDE_DIR ${PROJECT_SOURCE_DIR}/extern)
  add_library(Catch INTERFACE)
  target_include_directories(Catch INTERFACE ${CATCH_INCLUDE_DIR})

  configure_file(${PROJECT_SOURCE_DIR}/check/HCheckConfig.h.in ${HIGHS_BINARY_DIR}/HCheckConfig.h)

  FILE(WRITE ${CMAKE_BINARY_DIR}/testoptions.txt
  "mip_rel_gap=0.0
  mip_abs_gap=0.0")

  # Make test executable
  set(TEST_SOURCES
      TestAlienBasis.cpp
      TestBasis.cpp
      TestBasisSolves.cpp
      TestCallbacks.cpp
      TestCheckSolution.cpp
      TestCrossover.cpp
      TestDualize.cpp
      TestEkk.cpp
      TestFactor.cpp
      TestFilereader.cpp
      TestHighsCDouble.cpp
      TestHighsGFkSolve.cpp
      TestHighsHash.cpp
      TestHighsHessian.cpp
      TestHighsIntegers.cpp
      TestHighsModel.cpp
      TestHighsParallel.cpp
      TestHighsRbTree.cpp
      TestHighsSparseMatrix.cpp
      TestHighsVersion.cpp
      TestHSet.cpp
      TestICrash.cpp
      TestIis.cpp
      TestInfo.cpp
      TestIO.cpp
      TestIpm.cpp
      TestIpx.cpp
      TestLogging.cpp
      TestLPFileFormat.cpp
      TestLpModification.cpp
      TestLpOrientation.cpp
      TestLpSolvers.cpp
      TestLpValidation.cpp
      TestMain.cpp
      TestMipSolver.cpp
      TestModelProperties.cpp
      TestMultiObjective.cpp
      TestNames.cpp
      TestOptions.cpp
      TestPdlp.cpp
      TestPresolve.cpp
      TestQpSolver.cpp
      TestRanging.cpp
      TestRays.cpp
      TestSemiVariables.cpp
      TestSetup.cpp
      TestSort.cpp
      TestSpecialLps.cpp
      TestThrow.cpp
      TestTspSolver.cpp
      TestUserScale.cpp
      Avgas.cpp)

  set(OPT_LEVEL_CHANGED OFF)

  if(CMAKE_CXX_FLAGS_RELEASE MATCHES "-O[0-9s]" AND NOT CMAKE_CXX_FLAGS_RELEASE MATCHES "-O3")
    # message(MESSAGE "User has overridden the default optimization level for Release mode.")
    set(OPT_LEVEL_CHANGED ON)
  endif()

  if (LINUX AND NOT OPT_LEVEL_CHANGED AND CMAKE_CXX_COMPILER_ID STREQUAL "g++" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    if (NOT ((${CMAKE_SYSTEM_PROCESSOR} STREQUAL "arm64")) AND 
        NOT (${CMAKE_SYSTEM_PROCESSOR} MATCHES "riscv(32|64)"))
        set(TEST_SOURCES ${TEST_SOURCES} TestLpSolversIterations.cpp)
    endif()
  endif()

  if (BUILD_EXTRA_UNIT_TESTS)
      list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/check/highs-unit-tests")
      message(STATUS "${PROJECT_SOURCE_DIR}/check/highs-unit-tests")
      include(highs-unit-tests)

      set(TEST_SOURCES ${TEST_SOURCES} ${HIGHS_EXTRA_UNIT_TESTS})
      message(STATUS ${TEST_SOURCES})
  endif()

  add_executable(unit_tests ${TEST_SOURCES})

  if (UNIX)
      target_compile_options(unit_tests PRIVATE "-Wno-unused-variable")
      target_compile_options(unit_tests PRIVATE "-Wno-unused-const-variable")
  endif()

  if (FAST_BUILD)
    target_link_libraries(unit_tests highs Catch)

    if (CUPDLP_GPU)
        if (WIN32)
            target_link_libraries(unit_tests cudalin ${CUDA_LIBRARY})
        else()
            target_link_libraries(unit_tests cudalin ${CUDA_LIBRARY} m)
        endif()
        target_include_directories(unit_tests PRIVATE ${PROJECT_SOURCE_DIR}/highs/pdlp/cupdlp/cuda)
        set_target_properties(unit_tests PROPERTIES CUDA_SEPARABLE_COMPILATION ON)
    endif()
  else()
    target_link_libraries(unit_tests libhighs Catch)
  endif()

  include(GNUInstallDirs)
  if(APPLE)
      set_target_properties(unit_tests PROPERTIES INSTALL_RPATH
      "@loader_path/../${CMAKE_INSTALL_LIBDIR};@loader_path")
  elseif(UNIX)
      cmake_path(RELATIVE_PATH CMAKE_INSTALL_FULL_LIBDIR
          BASE_DIRECTORY ${CMAKE_INSTALL_FULL_BINDIR}
          OUTPUT_VARIABLE libdir_relative_path)
      set_target_properties(unit_tests PROPERTIES 
      INSTALL_RPATH "$ORIGIN/${libdir_relative_path}")
  endif()


  # check the C API
  add_executable(capi_unit_tests TestCAPI.c)

  if (FAST_BUILD)
    target_link_libraries(capi_unit_tests highs)
  else()
    target_link_libraries(capi_unit_tests libhighs)
  endif()

  add_test(NAME capi_unit_tests COMMAND capi_unit_tests)

  # Check whether test executable builds OK.
  if (NOT HIGHS_COVERAGE)
    add_test(NAME unit-test-build
            COMMAND ${CMAKE_COMMAND}
                    --build ${HIGHS_BINARY_DIR}
                    --target unit_tests
                    #  --config ${CMAKE_BUILD_TYPE}
            )

    # Avoid that several build jobs try to concurretly build.
    set_tests_properties(unit-test-build
                        PROPERTIES
                        RESOURCE_LOCK unittestbin)

    # create a binary running all the tests in the executable
    add_test(NAME unit_tests_all COMMAND unit_tests --success)
    set_tests_properties(unit_tests_all
                        PROPERTIES
                        DEPENDS unit-test-build)
    set_tests_properties(unit_tests_all PROPERTIES TIMEOUT 10000) 
  else()
    add_test(NAME unit_tests_all COMMAND unit_tests --success)
    set_tests_properties(unit_tests_all PROPERTIES TIMEOUT 10000) 
  endif()

  # An individual test can be added with the command below but the approach
  # above with a single add_test for all the unit tests automatically detects all
  # TEST_CASEs in the source files specified in TEST_SOURCES. Do not define any
  # tests in TestMain.cpp and do not define CATCH_CONFIG_MAIN anywhere else.
  # add_test(NAME correct-print-test COMMAND unit_tests correct-print)

  # --------------------------------------
  # Another way of adding the tests. Needs a script from github repo and a
  # Catch2 installation. So add tests manually if there is no build issues.
  # catch_discover_tests(unit_test)

  # --------------------------------------
  # Run instance tests.
  #
  # define the set of feasible instances
  set(successInstances
      "25fv47\;3149\; 5.5018458883\;"
      "80bau3b\;3686\; 9.8722419241\;"
      "adlittle\;74\; 2.2549496316\;"
      "afiro\;22\;-4.6475314286\;"
      "etamacro\;532\;-7.5571523330\;"
      "greenbea\;5109\;-7.2555248130\;"
      "shell\;623\; 1.2088253460\;"
      "stair\;529\;-2.5126695119\;"
      "standata\;72\; 1.2576995000\;"
      "standgub\;68\; 1.2576995000\;"
      "standmps\;218\; 1.4060175000\;"
      )
  
   set(successMacArmInstances
      "25fv47\;3103\; 5.5018458883\;"
      "80bau3b\;3705\; 9.8722419241\;"
      "adlittle\;74\; 2.2549496316\;"
      "afiro\;22\;-4.6475314286\;"
      "etamacro\;531\;-7.5571523330\;"
      "greenbea\;5156\;-7.2555248130\;"
      "shell\;623\; 1.2088253460\;"
      "stair\;531\;-2.5126695119\;"
      "standata\;72\; 1.2576995000\;"
      "standgub\;68\; 1.2576995000\;"
      "standmps\;218\; 1.4060175000\;"
   )

   set(successRiscVInstances
      "25fv47\;3103\; 5.5018458\;"
      "80bau3b\;3705\; 9.8722419\;"
      "etamacro\;531\;-7.5571523\;"
      "greenbea\;5156\;-7.2555248\;"
      "stair\;531\;-2.5126695\;" # last like mac arm
      "adlittle\;74\; 2.2549496\;"
      "afiro\;22\;-4.6475314\;"
      "shell\;623\; 1.2088253\;"
      "standata\;72\; 1.2576995\;"
      "standgub\;68\; 1.2576995\;"
      "standmps\;218\; 1.4060175\;"
   )

  set(infeasibleInstances
      "bgetam\;        infeasible"
      "box1\;          infeasible"
      "ex72a\;         infeasible"
      "forest6\;       infeasible"
      "galenet\;       infeasible"
      "gams10am\;      infeasible"
  #    "klein1\;        infeasible"
      "refinery\;      infeasible"
      "woodinfe\;      infeasible"
      )

  set(unboundedInstances
      "gas11\;         unbounded"
      )

  set(failInstances
      )
  
  set(mipInstances 
      "small_mip\;3.2368421\;"
      "flugpl\;1201500\;"
      "lseu\;1120|1119.9999999\;"
      "egout\;(568.1007|568.1006999)\;"
      "gt2\;21166\;"
      "rgn\;82.1999992\;"
      "bell5\;(8966406.49152|8966406.491519|8966406.49151)\;"
      "sp150x300d\;(69|68.9999999)\;"
      "p0548\;(8691|8690.9999999)\;"
      "dcmulti\;188182\;"
      )

  # define settings
  set(settings
      "--presolve=off"
      "--presolve=on"
      "--random_seed=1"
      "--random_seed=2"
      "--random_seed=3"
  #   "--random_seed=4"
  #   "--random_seed=5"
  #   "--parallel=on"
      )

  if (UNIX AND NOT APPLE AND NOT CMAKE_CXX_COMPILER_ID STREQUAL "IntelLLVM")
    if (CUPDLP_GPU)
        set(pdlpInstances
            "25fv47\; 5.501847\;"
            "adlittle\; 2.254949\;"
            "afiro\;-4.647531\;"
            "avgas\;-7.7499999\;"
            "blending\;-3.19999999\;"
            "chip\;-9.0000000\;"
            "e226\;-1.1638932\;"
            "scrs8\; 9.042968\;"
            "sctest\; 5.750000001\;"
            "shell\; 1.20882535\;"
            "stair\;-2.5126695\;"
            "standata\; 1.2576995\;"
            "standgub\; 1.2576994\;"
            )
    else() # CUPDLP_CPU
        set(pdlpInstances
            "25fv47\; 5.5018469\;"
            "adlittle\; 2.254949\;"
            "afiro\;-4.64753150\;"
            "avgas\;-7.7499999\;"
            "blending\;-3.1999999\;"
            "chip\;-8.9999999\;"
            "e226\;-1.16389294\;"
            "scrs8\; 9.04297094\;"
            "sctest\; 5.75000000\;"
            "shell\; 1.20882534\;"
            "stair\;-2.51266942\;"
            "standata\; 1.25769944\;"
            "standgub\; 1.25769944\;"
            )
    endif()
  elseif(WIN32 AND NOT CMAKE_CXX_COMPILER_ID STREQUAL "IntelLLVM")
    if (CUPDLP_GPU)
        set(pdlpInstances
            "25fv47\; 5.50184\;"
            "adlittle\; 2.254949\;"
            "afiro\;-4.647531\;"
            "avgas\;-7.749999\;"
            "blending\;-3.19999999\;"
            "chip\;-9.0000000\;"
            "scrs8\; 9.0429693\;"
            "sctest\; 5.7500000\;"
            "shell\; 1.20882535\;"
            "stair\;-2.512669\;" # 96 release 95 debug
            "standata\; 1.2576995\;"
            "standgub\; 1.257699\;"
            )
    else() # CUPDLP_CPU
        # on windows e226 model status is unknown
        # on windows 25fv47 model status can be unknown, with objective 5.5018458957e+03
        set(pdlpInstances
            "25fv47\; 5.50184\;"
            "adlittle\; 2.25494944\;"
            "afiro\;-4.647531504\;"
            "avgas\;-7.7499999\;"
            "blending\;-3.19999999\;"
            "chip\;-8.9999999\;"
            "scrs8\; 9.04297094\;"
            "sctest\; 5.7500000\;"
            "shell\; 1.20882534\;"
            "stair\;-2.51266942\;"
            "standata\; 1.257699393\;"
            "standgub\; 1.25769939\;"
            )
    endif()
  elseif(APPLE)
    set(pdlpInstances
        "25fv47\; 5.501846\;"
        "adlittle\; 2.254949\;"
        "afiro\;-4.647531\;"
        "avgas\;-7.7499999\;"
        "blending\;-3.19999999\;"
        "chip\;-9.0000000\;"
        "e226\;-1.16389\;"
        "scrs8\; 9.04296\;"
        "sctest\; 5.75000000\;"
        "shell\; 1.20882535\;"
        "stair\;-2.5126\;"
        "standata\; 1.25769947\;"
        "standgub\; 1.2576994\;"
    )
  endif()


  # define a macro to add tests
  #
  # add_instancetests takes an instance group and a status
  # that the solver should report as arguments
  macro(add_instancetests instances solutionstatus)
  # loop over the instances
  foreach(instance ${${instances}})
      # add default tests
      # treat the instance as a tuple (list) of two values
      list(GET instance 0 name)
      list(GET instance 1 iter)

      if(${solutionstatus} STREQUAL "Optimal")
          list(GET instance 2 optval)
      endif()

=== highs/CMakeLists.txt ===
if (NOT BUILD_CXX)
  return()
endif()
  
# Define library.
include(sources)
set(sources ${highs_sources} ${cupdlp_sources} ${ipx_sources} ${basiclu_sources})
set(headers ${highs_headers} ${cupdlp_headers} ${ipx_headers} ${basiclu_headers})

# Configure the config windows version file
if(MSVC)
  string(REPLACE "." ","  PROJECT_RC_VERSION "${PROJECT_VERSION}")
  configure_file(${PROJECT_SOURCE_DIR}/version.rc.in
    "${HIGHS_BINARY_DIR}/version.rc" @ONLY)
  set(win_version_file ${HIGHS_BINARY_DIR}/version.rc)
else()
  set(win_version_file)
endif()

# Outdated CMake approach: update in progress
if(NOT FAST_BUILD)

  add_library(libhighs ${sources} ${headers} ${win_version_file})
  target_include_directories(libhighs PRIVATE ${include_dirs})

  if(${BUILD_SHARED_LIBS})
    # put version information into shared library file
    set_target_properties(libhighs PROPERTIES
      VERSION
      ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR}.${HIGHS_VERSION_PATCH}
      SOVERSION ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR})
    if(MINGW)
      target_compile_definitions(libhighs PUBLIC LIBHIGHS_STATIC_DEFINE)
    endif()
  else()
    # create static highs library with pic
    set_target_properties(libhighs PROPERTIES
      POSITION_INDEPENDENT_CODE on)
    target_compile_definitions(libhighs PUBLIC LIBHIGHS_STATIC_DEFINE)
  endif()

  # on UNIX system the 'lib' prefix is automatically added
  set_target_properties(libhighs PROPERTIES
    OUTPUT_NAME "highs"
    PDB_NAME "libhighs"
    MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

  if(ZLIB AND ZLIB_FOUND)
    target_link_libraries(libhighs ZLIB::ZLIB)
    set(CONF_DEPENDENCIES "include(CMakeFindDependencyMacro)\nfind_dependency(ZLIB)")
  endif()

  # set the install rpath to the installed destination
  set_target_properties(libhighs PROPERTIES INSTALL_RPATH
    "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

  # install the header files of highs
  foreach(file ${headers})
    get_filename_component(dir ${file} DIRECTORY)

    if(NOT dir STREQUAL "")
      string(REPLACE ../extern/ "" dir ${dir})
    endif()

    install(FILES ${file} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs/${dir})
  endforeach()
  install(FILES ${HIGHS_BINARY_DIR}/HConfig.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  if(UNIX)
    # target_compile_options(libhighs PRIVATE "-Wno-defaulted-function-deleted")
    # target_compile_options(libhighs PRIVATE "-Wno-return-type-c-linkage")
    target_compile_options(libhighs PRIVATE "-Wno-return-type" "-Wno-switch")

    target_compile_options(libhighs PRIVATE "-Wno-unused-variable")
    target_compile_options(libhighs PRIVATE "-Wno-unused-const-variable")

    # target_compile_options(libhighs PRIVATE "-Wno-sign-compare")
    # target_compile_options(libhighs PRIVATE "-Wno-logical-op-parentheses")

    # target_compile_options(libipx PRIVATE "-Wno-defaulted-function-deleted")
    # target_compile_options(libipx PRIVATE "-Wno-return-type-c-linkage")
    # target_compile_options(libipx PRIVATE "-Wno-return-type" "-Wno-switch")

    # target_compile_options(libipx PRIVATE "-Wno-sign-compare")
    # target_compile_options(libipx PRIVATE "-Wno-logical-op-parentheses")
  endif()
  
  install(TARGETS libhighs EXPORT highs-targets
    LIBRARY
    ARCHIVE
    RUNTIME
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  # Add library targets to the build-tree export set
  export(TARGETS libhighs
    FILE "${HIGHS_BINARY_DIR}/highs-targets.cmake")

  # Configure the config file for the build tree:
  # Either list all the highs/* directories here, or put explicit paths in all the
  # include statements.
  # M reckons that the latter is more transparent, and I'm inclined to agree.
  set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/highs" "${HIGHS_BINARY_DIR}")
  configure_file(${PROJECT_SOURCE_DIR}/cmake/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}/highs-config.cmake" @ONLY)

  # Configure the config file for the install
  set(CONF_INCLUDE_DIRS "\${CMAKE_CURRENT_LIST_DIR}/../../../${CMAKE_INSTALL_INCLUDEDIR}/highs")
  configure_file(${PROJECT_SOURCE_DIR}/cmake/highs-config.cmake.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake" @ONLY)

  # Configure the pkg-config file for the install
  configure_file(${PROJECT_SOURCE_DIR}/highs.pc.in
    "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc" @ONLY)

  # Install the targets of the highs export group, the config file so that other
  # cmake-projects can link easily against highs, and the pkg-config flie so that
  # other projects can easily build against highs
  install(EXPORT highs-targets FILE highs-targets.cmake DESTINATION
    ${CMAKE_INSTALL_LIBDIR}/cmake/highs)
  install(FILES "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs-config.cmake"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/highs)
  install(FILES "${HIGHS_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/highs.pc"
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

else()
  # FAST_BUILD is set to on.
  # At the moment used only for gradually updating the CMake targets build and
  # install / export.
  # Define library in modern CMake using target_*()
  # No interfaces (apart from c); No ipx; New (short) ctest instances.
  add_library(highs)

  add_library(${PROJECT_NAMESPACE}::highs ALIAS highs)

  if(${BUILD_SHARED_LIBS})
    # put version information into shared library file
    set_target_properties(highs PROPERTIES
      VERSION
      ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR}.${HIGHS_VERSION_PATCH}
      SOVERSION ${HIGHS_VERSION_MAJOR}.${HIGHS_VERSION_MINOR})
  endif()

  set_target_properties(highs PROPERTIES POSITION_INDEPENDENT_CODE ON)

  if(APPLE)
      set_target_properties(highs PROPERTIES INSTALL_RPATH "@loader_path")
  elseif (UNIX)
      set_target_properties(highs PROPERTIES INSTALL_RPATH "$ORIGIN")
  endif()


  target_sources(highs PRIVATE ${sources} ${headers} ${win_version_file})
  
  # Optional Cuda 
  if (CUPDLP_GPU)

    target_include_directories(highs PUBLIC "$<BUILD_INTERFACE:${CMAKE_CUDA_PATH}/include>")
    set(CUPDLP_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/highs/pdlp/cupdlp/")

    add_subdirectory(pdlp/cupdlp/cuda)

    if (WIN32)
      target_link_libraries(highs cudalin ${CUDA_LIBRARY})
    else()
      target_link_libraries(highs cudalin ${CUDA_LIBRARY} m)
    endif()
    
    set_target_properties(highs PROPERTIES CUDA_SEPARABLE_COMPILATION ON)

  endif()

  target_include_directories(highs PRIVATE ${include_dirs})

  if(MSVC)
    list(APPEND highs_compile_opts
      "/bigobj" # Allow big object
      "/DNOMINMAX"
      "/DWIN32_LEAN_AND_MEAN=1"
      "/D_CRT_SECURE_NO_WARNINGS"
      "/D_CRT_SECURE_NO_DEPRECATE"
      "/MP" # Build with multiple processes
      "/Zc:preprocessor" # Enable preprocessor conformance mode
      "/fp:precise"
      )
    if (CMAKE_BUILD_TYPE STREQUAL Release)
      list(APPEND highs_compile_opts
        "/DNDEBUG")
    endif()
    # MSVC warning suppressions
    list(APPEND highs_compile_opts
      "/wd4005" # 'macro-redefinition'
      "/wd4018" # 'expression' : signed/unsigned mismatch
      "/wd4065" # switch statement contains 'default' but no 'case' labels
      "/wd4068" # 'unknown pragma'
      "/wd4101" # 'identifier' : unreferenced local variable
      "/wd4146" # unary minus operator applied to unsigned type, result still unsigned
      "/wd4200" # nonstandard extension used : zero-sized array in struct/union
      "/wd4244" # 'conversion' conversion from 'type1' to 'type2', possible loss of data
      "/wd4251" # 'identifier' : class 'type' needs to have dll-interface to be used by clients of class 'type2'
      "/wd4267" # 'var' : conversion from 'size_t' to 'type', possible loss of data
      "/wd4305" # 'identifier' : truncation from 'type1' to 'type2'
      "/wd4307" # 'operator' : integral constant overflow
      "/wd4309" # 'conversion' : truncation of constant value
      "/wd4334" # 'operator' : result of 32-bit shift implicitly converted to 64 bits (was 64-bit shift intended?)
      "/wd4355" # 'this' : used in base member initializer list
      "/wd4477" # 'fwprintf' : format string '%s' requires an argument of type 'wchar_t *'
      "/wd4506" # no definition for inline function 'function'
      "/wd4715" # function' : not all control paths return a value
      "/wd4800" # 'type' : forcing value to bool 'true' or 'false' (performance warning)
      "/wd4996" # The compiler encountered a deprecated declaration.
      )
    target_compile_options(highs PRIVATE ${highs_compile_opts})
  # else()
  #   list(APPEND highs_compile_opts "-fwrapv")
  endif()


  if(ZLIB AND ZLIB_FOUND)
    target_include_directories(highs PRIVATE
      $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/extern/zstr>
    )
    target_link_libraries(highs ZLIB::ZLIB)
  endif()
    
  # install the header files of highs
  foreach(file ${headers})
    get_filename_component(dir ${file} DIRECTORY)

    if(NOT dir STREQUAL "")
      string(REPLACE ../extern/ "" dir ${dir})
    endif()

    install(FILES ${file} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs/${dir})
  endforeach()
  install(FILES ${HIGHS_BINARY_DIR}/HConfig.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/highs)

  # target_compile_options(highs PRIVATE "-Wall")
  # target_compile_options(highs PRIVATE "-Wunused")
  
  if (UNIX)
    if ( CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")   
      target_compile_options(highs PRIVATE "-Wall")
      target_compile_options(highs PRIVATE "-Wreturn-type")
      target_compile_options(highs PRIVATE "-Wmissing-declarations")
      target_compile_options(highs PRIVATE "-Wno-unused-variable")
      target_compile_options(highs PRIVATE "-Wno-unused-const-variable")
      target_compile_options(highs PRIVATE "-Wno-unused-but-set-variable")
      target_compile_options(highs PRIVATE "-Wno-comment")
      target_compile_options(highs PRIVATE "-Wno-unused-label")

      if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")   
        target_compile_options(highs PRIVATE "-Wno-unused-lambda-capture")
      endif()

    else()
      target_compile_options(highs PRIVATE "-Wno-unused-variable")
      target_compile_options(highs PRIVATE "-Wno-unused-const-variable")
    endif()
  endif()
  if (CMAKE_CXX_COMPILER_ID STREQUAL "IntelLLVM")
    target_compile_options(highs PUBLIC "-Wno-invalid-offsetof")
  endif()

  check_cxx_compiler_flag("-Wno-invalid-offsetof" COMPILER_SUPPORTS_INVALID_OFFSET)
  if(COMPILER_SUPPORTS_INVALID_OFFSET)
      target_compile_options(highs PUBLIC "$<$<COMPILE_LANGUAGE:CXX>:-Wno-invalid-offsetof>")
  endif()

  if (BUILD_DOTNET)
  
      # see: https://docs.microsoft.com/en-us/dotnet/core/rid-catalog
      if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(aarch64|arm64)")
        set(DOTNET_PLATFORM arm64)
      else()
        set(DOTNET_PLATFORM x64)
      endif()

      if(APPLE)
        set(DOTNET_RID osx-${DOTNET_PLATFORM})
      elseif(UNIX)
        set(DOTNET_RID linux-${DOTNET_PLATFORM})
      elseif(WIN32)
        set(DOTNET_RID win-${DOTNET_PLATFORM})
      else()
        message(FATAL_ERROR "Unsupported system !")
      endif()
      message(STATUS ".Net RID: ${DOTNET_RID}")

      set(DOTNET_PROJECT Highs.Native)
      set(DOTNET_PROJECT_DIR ${PROJECT_BINARY_DIR}/dotnet/${DOTNET_PROJECT})
      file(MAKE_DIRECTORY ${DOTNET_PROJECT_DIR}/runtimes/${DOTNET_RID}/native)

      if (APPLE)
        set(TARGET_FILE_NAME "highs.dylib")
      elseif(UNIX)
        set(TARGET_FILE_NAME "highs.so")
      elseif(WIN32)
        set(TARGET_FILE_NAME "highs.dll")
      endif()

      add_custom_command(TARGET highs POST_BUILD 
        COMMAND "${CMAKE_COMMAND}" -E copy 
          "$<TARGET_FILE:highs>"
        ${DOTNET_PROJECT_DIR}/runtimes/${DOTNET_RID}/native/${TARGET_FILE_NAME}
        COMMENT "Copying to output directory")
  endif()

endif()

if(FORTRAN_FOUND)
  set(fortransources interfaces/highs_fortran_api.f90)
  set(CMAKE_Fortran_MODULE_DIRECTORY ${HIGHS_BINARY_DIR}/modules)

=== debian/changelog ===
highs (1.11.0+ds-1) unstable; urgency=medium

  * New upstream version 1.11.0+ds.
  * d/patches: refresh existing patches.
  * d/rules: update FULLVERSION to 1.11.0.
  * d/copyright: update according to upstream.

 -- Shengqi Chen <harry@debian.org>  Fri, 15 Aug 2025 00:19:07 +0800

=== debian/control ===
Source: highs
Section: science
Priority: optional
Standards-Version: 4.7.2
Maintainer: Debian Science Maintainers <debian-science-maintainers@alioth-lists.debian.net>
Uploaders: Shengqi Chen <harry@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-sequence-python3,
               help2man,
               libz-dev,
               libcatch2-dev <!nocheck>,
               ninja-build,
               pybuild-plugin-pyproject,
               python3-dev,
               python3-numpy,
               python3-pybind11,
               python3-pytest <!nocheck>,
               python3-scikit-build-core
Homepage: https://highs.dev/
Vcs-Git: https://salsa.debian.org/science-team/highs.git
Vcs-Browser: https://salsa.debian.org/science-team/highs
Rules-Requires-Root: no

Package: libhighs1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: highs
Description: High performance linear optimization software (shared library)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the libhighs1 shared library.

Package: python3-highspy
Section: python
Architecture: any
Depends: libhighs1 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: High performance linear optimization software (Python library)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the Python library for HiGHS.

Package: libhighs-dev
Section: libdevel
Architecture: any
Depends: libhighs1 (= ${binary:Version}), ${misc:Depends}
Description: High performance linear optimization software (development files)
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the development files for libhighs.

Package: highs
Architecture: any
Depends: libhighs1 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: High performance linear optimization software
 HiGHS is a high performance serial and parallel solver for large scale
 sparse linear optimization problems, including linear programming (LP)
 problems, convex quadratic programming (QP) problems, and mixed integer
 programming (MIP) problems.
 .
 This package contains the HiGHS solver.

=== debian/rules ===
#!/usr/bin/make -f

SOVERSION=1
FULLVERSION=1.11.0

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# these files are to be moved out of python3-highspy package after built
TARGET_PREFIX = debian/tmp/usr
TARGET_LIBDIR = $(TARGET_PREFIX)/lib/$(DEB_HOST_MULTIARCH)
SYSTEM_LIBDIR = usr/lib/$(DEB_HOST_MULTIARCH)

# we need a hardcoded path to find in dh_auto_test
BUILDDIR = /tmp/highs-build
BUILD_LIBDIR = $(BUILDDIR)/$(TARGET_LIBDIR)

SKBUILD_ARGS = \
	-C skbuild.build-dir=$(BUILDDIR) \
	-C skbuild.ninja.version=">=1.5" \
	-C skbuild.build.verbose=true \
	-C skbuild.install.strip=false \
	-C skbuild.cmake.build-type=RelWithDebInfo \
	-C skbuild.cmake.args=-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
	-C skbuild.cmake.args=-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
	-C skbuild.cmake.args=-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
	-C skbuild.cmake.args=-DPYTHON_BUILD_SETUP=ON \
	-C skbuild.cmake.args=-DFAST_BUILD=ON \
	-C skbuild.cmake.args=-DBUILD_SHARED_LIBS=ON \
	-C skbuild.cmake.args=-DCMAKE_INSTALL_PREFIX=/usr \
	-C skbuild.cmake.args=-DCMAKE_INSTALL_LIBDIR=$(TARGET_LIBDIR) \
	-C skbuild.cmake.args=-DCMAKE_INSTALL_INCLUDEDIR=$(TARGET_PREFIX)/include

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	SKBUILD_ARGS += -C skbuild.cmake.args=-DALL_TESTS=ON
endif

# config pybuild and skbuild
export PYBUILD_NAME = highspy
export PYBUILD_SYSTEM = pyproject
export PYBUILD_BUILD_ARGS_$(shell py3versions -d) = $(SKBUILD_ARGS)

PY_DEST_DIR=debian/python3-highspy/usr/lib/$(shell py3versions -d)/dist-packages

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# the tests use regex to match FP numbers precisely,
# thus are only reproducible on amd64 ISAs
ifeq ($(DEB_BUILD_ARCH_CPU),amd64)
	cd $(BUILDDIR) && ctest --output-on-failure
endif
	# set LD_LIBRARY_PATH to find compiled _core.so and libhighs.so
	LD_LIBRARY_PATH=$(shell realpath $(BUILD_LIBDIR)) dh_auto_test
endif

execute_after_dh_auto_install:
	# move files out of python3-highspy package
	mkdir -p debian/tmp/
	mv $(PY_DEST_DIR)/$(TARGET_PREFIX) $(TARGET_PREFIX)
	mv $(PY_DEST_DIR)/bin $(TARGET_PREFIX)/bin # CMAKE_INSTALL_BINDIR does not work, I don't know why
	rm -rf $(PY_DEST_DIR)/debian
	# remove hardcoded build path
	sed -i 's|#define HIGHS_DIR .*|#define HIGHS_DIR "/usr"|' $(TARGET_PREFIX)/include/highs/HConfig.h
	# generate manpage from help
	LD_LIBRARY_PATH=$(TARGET_LIBDIR) help2man --version-string=$(DEB_VERSION_UPSTREAM) --name="HiGHS -- High performance linear optimization software" -N -o highs.1 $(TARGET_PREFIX)/bin/highs

execute_after_dh_install:
	# replace duplicated .so files (copied when building wheels) with symlinks
	dh_link -p libhighs$(SOVERSION) $(SYSTEM_LIBDIR)/libhighs.so.$(FULLVERSION) $(SYSTEM_LIBDIR)/libhighs.so.$(SOVERSION)
	dh_link -p libhighs-dev $(SYSTEM_LIBDIR)/libhighs.so.$(SOVERSION) $(SYSTEM_LIBDIR)/libhighs.so

## highs 1.12.0%2Bds1

=== CMakeLists.txt ===
# The top-level CMake file is there to bring all modules into scope. That
# means, adding the subdirectories for all CMake projects in this tree, and
# finding external libraries and turning them into imported targets.

# Require CMake 3.15+ (matching scikit-build-core) Use new versions of all
# policies up to CMake 3.27
cmake_minimum_required(VERSION 3.15...3.27)

# set preference for clang compiler and intel compiler over gcc and other compilers
include(Platform/${CMAKE_SYSTEM_NAME}-Determine-C OPTIONAL)
include(Platform/${CMAKE_SYSTEM_NAME}-C OPTIONAL)
set(CMAKE_C_COMPILER_NAMES clang gcc icx cc ${CMAKE_C_COMPILER_NAMES})

include(Platform/${CMAKE_SYSTEM_NAME}-Determine-CXX OPTIONAL)
include(Platform/${CMAKE_SYSTEM_NAME}-CXX OPTIONAL)
set(CMAKE_CXX_COMPILER_NAMES clang++ g++ icpx c++ ${CMAKE_CXX_COMPILER_NAMES})

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(set-version)
set_version(VERSION)

project(HIGHS VERSION ${VERSION} LANGUAGES CXX C)

set(PROJECT_NAMESPACE highs)
message(STATUS "${PROJECT_NAME} version: ${PROJECT_VERSION}")

# use C++11 standard
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Require out-of-source builds
file(TO_CMAKE_PATH "${PROJECT_BINARY_DIR}/CMakeLists.txt" LOC_PATH)
if(EXISTS "${LOC_PATH}")
  message(FATAL_ERROR "You cannot build in a source directory (or any directory with a CMakeLists.txt file).
    Please make a build subdirectory. Feel free to remove CMakeCache.txt and CMakeFiles.")
endif()
option(FAST_BUILD "Fast build: " ON)

find_program(GIT git)

if((GIT) AND(EXISTS ${PROJECT_SOURCE_DIR}/.git))
    execute_process(
    COMMAND ${GIT} status
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR} OUTPUT_QUIET)

    execute_process(
    COMMAND ${GIT} describe --always
    WORKING_DIRECTORY ${PROJECT_SOURCE_DIR}
    OUTPUT_VARIABLE GITHASH OUTPUT_STRIP_TRAILING_WHITESPACE)
  # string(REGEX REPLACE "^.*-g" "" GITHASH ${GITHASH})
else()
  set(GITHASH "n/a")
endif()

# message("CMAKE_CXX_COMPILER_ID is ${CMAKE_CXX_COMPILER_ID}")
if (CMAKE_CXX_COMPILER_ID STREQUAL "IntelLLVM")
  message(STATUS "Compiler is IntelLLVM")
  if (CMAKE_HOST_WIN32 AND CMAKE_VERSION VERSION_LESS "3.23.0")
      message(FATAL_ERROR "Need at least CMake 3.23 for IntelLLVM support of IntelDPCPP package on Windows")
  elseif(CMAKE_VERSION VERSION_LESS "3.23.0")
      message(FATAL_ERROR "CMake 3.20.5 is the minimum recommended for IntelLLVM on Linux")
  endif()

  find_package(IntelSYCL REQUIRED)
endif()


message(STATUS "Git hash: " ${GITHASH})
# By default only build the C++ library.
option(BUILD_CXX "Build C++ library" ON)
message(STATUS "Build C++ library: ${BUILD_CXX}")

option(BUILD_CXX_EXE "Build C++ executable" ON)
message(STATUS "Build C++ executable: ${BUILD_CXX_EXE}")

option(BUILD_TESTING "Build Tests" ON)

option(FORTRAN "Build Fortran interface" OFF)
message(STATUS "Build Fortran: ${FORTRAN}")
option(CSHARP "Build CSharp interface" OFF)
message(STATUS "Build CSharp: ${CSHARP}")

if (FORTRAN OR CSHARP)
  set(BUILD_SHARED_LIBS ON)
endif()

option(PYTHON_BUILD_SETUP "Build Python interface from setup.py" OFF)
message(STATUS "Build Python: ${PYTHON_BUILD_SETUP}")
if (PYTHON_BUILD_SETUP)
  set(BUILD_CXX OFF)
  set(BUILD_TESTING OFF)
endif()

include(CMakeDependentOption)

CMAKE_DEPENDENT_OPTION(ALL_TESTS "Build all tests" OFF "BUILD_TESTING;BUILD_CXX" OFF)
message(STATUS "Build all tests: ${ALL_TESTS}")

option(BUILD_EXTRA_UNIT_TESTS "Build extra unit tests" OFF)
if (BUILD_EXTRA_UNIT_TESTS)
  message(STATUS "Build extra unit tests: ON")
endif()

CMAKE_DEPENDENT_OPTION(BUILD_EXTRA_UNIT_ONLY "Build extra unit tests ONLY" OFF "BUILD_EXTRA_UNIT_TESTS" OFF)
if (BUILD_EXTRA_UNIT_ONLY)
  message(STATUS "Build only extra unit tests: ON")
endif()

CMAKE_DEPENDENT_OPTION(BUILD_EXTRA_PROBLEM_SET "Build extra instance tests" OFF "BUILD_TESTING" OFF)
if (BUILD_EXTRA_PROBLEM_SET)
  message(STATUS "Build extra instance tests: ON")
endif()

option(ZLIB "ZLIB" ON)
message(STATUS "ZLIB: ${ZLIB}")
if (PYTHON_BUILD_SETUP)
  set(ZLIB OFF)
endif()

option(HIGHS_COVERAGE "Activate the code coverage compilation" OFF)

# Address | Thread | Leak
# Linux atm
# Only Debug atm
# See below for RelWithDeb info, todo test wip
set(DEBUG_MEMORY "Off" CACHE STRING "Sanitizers")

# emscripten
option(EMSCRIPTEN_HTML "Emscripten HTML output" OFF)


option(CUPDLP_GPU "Build pdlp with GPU" OFF)
message(STATUS "Build pdlp with GPU: ${CUPDLP_GPU}")

option(CUPDLP_FIND_CUDA "Build pdlp with GPU" OFF)
message(STATUS "Use FindCUDAConf: ${CUPDLP_FIND_CUDA}")

if(CUPDLP_GPU AND CMAKE_VERSION VERSION_LESS "3.25.0")
    message("CUPDLP FindCUDAConf requires CMake version minumum 3.24. Please use a higher version of CMake.")
endif()

# if (NOT LINUX)
  # set (CUPDLP_GPU OFF)
  # message(STATUS "CUPLDP with Nvidia is only supported on Linux at the moment. Using CPU version.")
# endif()

option(HIPO "Build HIPO" OFF)
message(STATUS "Build HIPO: ${HIPO}")
if (HIPO AND CSHARP)
  message(ERROR "HIPO is only available in C++. Not yet supported in C#.")
endif()
if (HIPO AND FORTRAN)
  message(ERROR "HIPO is only available in C++. Not yet supported in FORTRAN")
endif()
if (HIPO AND PYTHON_BUILD_SETUP)
  message(ERROR "HIPO is only available in C++. Not yet supported in Python.")
endif()
if (HIPO AND NOT FAST_BUILD)
  message(ERROR "HIPO is only available with FAST_BUILD=ON.")
endif()

if (CUPDLP_GPU)
  if (WIN32)
    set(BUILD_SHARED_LIBS ON)
  endif()

  set (CUPDLP_CPU OFF)
  message(NOTICE "Set build cuPDLP with CUDA")

  if (CUPDLP_FIND_CUDA)
    # With FindCUDAConf.cmake
    # Need to have the CUDA_HOME environment variable set.
    include(FindCUDAConf)
  else()
    # Without FindCUDAConf.cmake
    enable_language(CUDA)
    find_package(CUDAToolkit REQUIRED)

    set(CUDA_LIBRARY-NOTFOUND, OFF)
    set(CUDA_LIBRARY CUDA::cudart CUDA::cublas CUDA::cusparse)
  endif()

else()
  set (CUPDLP_CPU ON)
    set(CUDA_LIBRARY-NOTFOUND true)
endif()

# HiPO deps
if(HIPO)
  # find_package(METIS REQUIRED)
  # find_package(GKlib REQUIRED)
  # does not work with outdated CMake
  include(FindHipoDeps)
endif()

if (BUILD_CXX)
  # Default Build Type to be Release
  get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(isMultiConfig)
    if(NOT CMAKE_CONFIGURATION_TYPES)
      set(CMAKE_CONFIGURATION_TYPES "Release;Debug" CACHE STRING
      "Choose the type of builds, options are: Debug Release RelWithDebInfo MinSizeRel. (default: Release;Debug)"
      FORCE)
    endif()
    message(STATUS "Configuration types: ${CMAKE_CONFIGURATION_TYPES}")
  else()
    if (CMAKE_BUILD_TYPE STREQUAL Release)
      set(HiGHSRELEASE ON)
      add_compile_definitions("NDEBUG")# whether to use shared or static libraries
    else()
      if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE "Release" CACHE STRING
        "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel. (default: Release)"
        FORCE)
        set(HiGHSRELEASE ON)
        add_compile_definitions("NDEBUG")
      endif()
    endif()
    message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
  endif()

  include(GNUInstallDirs)

  if(UNIX)
    option(BUILD_SHARED_LIBS "Build shared libraries (.so or .dyld)." ON)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
    # for multi-config build system (e.g. xcode)
    foreach(OutputConfig IN LISTS CMAKE_CONFIGURATION_TYPES)
      string(TOUPPER ${OutputConfig} OUTPUTCONFIG)
      set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OutputConfig}/${CMAKE_INSTALL_LIBDIR})
      set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OutputConfig}/${CMAKE_INSTALL_LIBDIR})
      set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OutputConfig}/${CMAKE_INSTALL_BINDIR})
    endforeach()
  else()
    option(BUILD_SHARED_LIBS "Build shared libraries (.dll)." OFF)
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})
    # for multi-config builds (e.g. msvc)
    foreach(OutputConfig IN LISTS CMAKE_CONFIGURATION_TYPES)
      string(TOUPPER ${OutputConfig} OUTPUTCONFIG)
      set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OutputConfig}/${CMAKE_INSTALL_BINDIR})
      set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OutputConfig}/${CMAKE_INSTALL_BINDIR})
      set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG} ${CMAKE_BINARY_DIR}/${OutputConfig}/${CMAKE_INSTALL_BINDIR})
    endforeach()
  endif()

  if(BUILD_SHARED_LIBS AND MSVC)
    set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
  endif()

  if (BUILD_TESTING)
    include(CTest)
  endif()

  if(MSVC)
    # This option is only available when building with MSVC. By default, highs
    # is build using the cdecl calling convention, which is useful if you're
    # writing C. However, the CLR and Win32 API both expect stdcall.
    #
    # If you are writing a CLR program and want to link to highs, you'll want
    # to turn this on by invoking CMake with the "-DSTDCALL=ON" argument.
    option(STDCALL "Build highs with the __stdcall convention" OFF)
  endif()

  if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR
    CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
  # elseif (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  # not recognised by cl
  #   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /std:c++11")
  endif()

  # Basic type
  include(CMakePushCheckState)
  cmake_push_check_state(RESET)
  set(CMAKE_EXTRA_INCLUDE_FILES "cstdint")
  include(CheckTypeSize)
  check_type_size("long" SIZEOF_LONG LANGUAGE CXX)
  message(STATUS "Found long size: ${SIZEOF_LONG}")
  check_type_size("long long" SIZEOF_LONG_LONG LANGUAGE CXX)
  message(STATUS "Found long long size: ${SIZEOF_LONG_LONG}")
  check_type_size("int64_t" SIZEOF_INT64_T LANGUAGE CXX)
  message(STATUS "Found int64_t size: ${SIZEOF_INT64_T}")

  check_type_size("unsigned long" SIZEOF_ULONG LANGUAGE CXX)
  message(STATUS "Found unsigned long size: ${SIZEOF_ULONG}")
  check_type_size("unsigned long long" SIZEOF_ULONG_LONG LANGUAGE CXX)
  message(STATUS "Found unsigned long long size: ${SIZEOF_ULONG_LONG}")
  check_type_size("uint64_t" SIZEOF_UINT64_T LANGUAGE CXX)
  message(STATUS "Found uint64_t size: ${SIZEOF_UINT64_T}")

  check_type_size("int *" SIZEOF_INT_P LANGUAGE CXX)
  message(STATUS "Found int * size: ${SIZEOF_INT_P}")
  cmake_pop_check_state()

  # Use current CMAKE_C_FLAGS and CMAKE_CXX_FLAGS when checking for IPO support,
  # instead of defaults: https://cmake.org/cmake/help/latest/policy/CMP0138.html
  if(MSVC AND BUILD_SHARED_LIBS)
    # MSVC does support LTO, but WINDOWS_EXPORT_ALL_SYMBOLS does not work if
    # LTO is enabled.
    set(ipo_supported NO)
    message(STATUS "IPO / LTO not supported on MSVC when building a shared library")
  elseif(MINGW AND NOT CLANG)
    # MinGW supports LTO, but it causes tests to fail at runtime like this:
    #
    #   Mingw-w64 runtime failure:
    #   32 bit pseudo relocation at 00007FF779C9D070 out of range, targeting 00007FFAAC101400, yielding the value 000000033246438C.
    #
    # TODO Figure out and fix the root cause of that, then remove this section.
    set(ipo_supported NO)
    message(STATUS "IPO / LTO not currently supported building HiGHS on MinGW")
  else()
    if(CMAKE_VERSION VERSION_GREATER_EQUAL  "3.24.0")
      cmake_policy(SET CMP0138 NEW)
    endif()

    include(CheckIPOSupported)
    check_ipo_supported(RESULT ipo_supported OUTPUT check_ipo_support_output)

## highs 1.12.0+ds

=== check/CMakeLists.txt ===
--- 
+++ 
@@ -48,6 +48,7 @@
       TestHighsRbTree.cpp
       TestHighsSparseMatrix.cpp
       TestHighsVersion.cpp
+      TestHipo.cpp
       TestHSet.cpp
       TestICrash.cpp
       TestIis.cpp
@@ -106,6 +107,8 @@
 
   add_executable(unit_tests ${TEST_SOURCES})
 
+  set_target_properties(unit_tests PROPERTIES UNITY_BUILD OFF)
+
   if (UNIX)
       target_compile_options(unit_tests PRIVATE "-Wno-unused-variable")
       target_compile_options(unit_tests PRIVATE "-Wno-unused-const-variable")
@@ -258,7 +261,7 @@
       "lseu\;1120|1119.9999999\;"
       "egout\;(568.1007|568.1006999)\;"
       "gt2\;21166\;"
-      "rgn\;82.1999992\;"
+      "rgn\;82.19999\;"
       "bell5\;(8966406.49152|8966406.491519|8966406.49151)\;"
       "sp150x300d\;(69|68.9999999)\;"
       "p0548\;(8691|8690.9999999)\;"
@@ -376,7 +379,3 @@
       list(GET instance 0 name)
       list(GET instance 1 iter)
 
-      if(${solutionstatus} STREQUAL "Optimal")
-          list(GET instance 2 optval)
-      endif()
-

=== debian/changelog ===
highs (1.12.0+ds-1) unstable; urgency=medium

  * d/watch: switch to version 5.
  * New upstream version 1.12.0+ds.
  * d/patches: refresh existing patches.
  * d/patches: remove more hardcoded RPATH settings from CMake.
  * d/rules: update FULLVERSION to 1.12.0.
  * d/rules: set CMAKE_BUILD_TYPE to None.

 -- Shengqi Chen <harry@debian.org>  Sun, 09 Nov 2025 23:10:18 +0800

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
 SOVERSION=1
-FULLVERSION=1.11.0
+FULLVERSION=1.12.0
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
@@ -22,7 +22,7 @@
 	-C skbuild.ninja.version=">=1.5" \
 	-C skbuild.build.verbose=true \
 	-C skbuild.install.strip=false \
-	-C skbuild.cmake.build-type=RelWithDebInfo \
+	-C skbuild.cmake.build-type=None \
 	-C skbuild.cmake.args=-DCMAKE_C_FLAGS="$(CFLAGS) $(CPPFLAGS)" \
 	-C skbuild.cmake.args=-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
 	-C skbuild.cmake.args=-DCMAKE_EXE_LINKER_FLAGS="$(LDFLAGS)" \
